## ayatana-indicator-sound 0.8.2-0+git20211102.2976+10.nightly.1

=== CMakeLists.txt ===
project(ayatana-indicator-sound C CXX)
cmake_minimum_required(VERSION 3.13)

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "..." FORCE)
endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

set(PACKAGE ${CMAKE_PROJECT_NAME})
set(PROJECT_VERSION 0.8.2)
find_package(PkgConfig REQUIRED)
include(GNUInstallDirs)
include(UseVala)

# Options
option(ENABLE_TESTS "Enable all tests and checks" OFF)
option(ENABLE_COVERAGE "Enable coverage reports (includes enabling all tests and checks)" OFF)
option(ENABLE_WERROR "Treat all build warnings as errors" OFF)

if(ENABLE_COVERAGE)
    set(ENABLE_TESTS ON)
    set(CMAKE_BUILD_TYPE "Coverage")
else()
    set(CMAKE_BUILD_TYPE "Release")
endif()

if(ENABLE_WERROR)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

set(GETTEXT_PACKAGE "ayatana-indicator-sound")
set(LOCALEDIR "${CMAKE_INSTALL_FULL_LOCALEDIR}")
add_definitions( -DGETTEXT_PACKAGE="${GETTEXT_PACKAGE}" )

set(SOURCE_DIR "${CMAKE_SOURCE_DIR}/src")
set(SOURCE_BINARY_DIR "${CMAKE_BINARY_DIR}/src")

set(PULSE_AUDIO_REQUIRED_VERSION 0.9.19)
set(GLIB_2_0_REQUIRED_VERSION 2.32)
set(GIO_2_0_REQUIRED_VERSION 2.25.13)

pkg_check_modules(
  PULSEAUDIO REQUIRED
  libpulse-mainloop-glib>=${PULSE_AUDIO_REQUIRED_VERSION}
  glib-2.0>=${GLIB_2_0_REQUIRED_VERSION}
  gio-unix-2.0>=${GIO_2_0_REQUIRED_VERSION}
)
include_directories(${PULSEAUDIO_INCLUDE_DIRS})

pkg_check_modules(
  SOUNDSERVICE REQUIRED
  gee-0.8
  gio-2.0>=${GIO_2_0_REQUIRED_VERSION}
  gio-unix-2.0
  gthread-2.0
  libxml-2.0
  libnotify
  accountsservice
  libayatana-common
)
include_directories(${SOUNDSERVICE_INCLUDE_DIRS})

pkg_check_modules(UNITY_API liblomiri-api>=0.1.1)

include_directories(${TEST_INCLUDE_DIRS})

find_package(Vala 0.20)

find_package(GObjectIntrospection 0.9.12)

include_directories(${SOURCE_DIR})
include_directories(${SOURCE_BINARY_DIR})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

add_definitions(
  -Wall
)

configure_file(
  "config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h"
)

add_subdirectory(data)
add_subdirectory(src)
add_subdirectory(po)

if (ENABLE_TESTS)
    pkg_check_modules(TEST REQUIRED dbustest-1>=15.04.0)
    enable_testing()
    add_subdirectory(tests)
    if (ENABLE_COVERAGE)
        find_package(CoverageReport)
        ENABLE_COVERAGE_REPORT(
            TARGETS ${COVERAGE_TARGETS}
            TESTS ${COVERAGE_TEST_TARGETS}
            FILTER /usr/include ${CMAKE_BINARY_DIR}/*
        )
    endif()
endif ()

# Display config info

message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Unit tests: ${ENABLE_TESTS}")
message(STATUS "Build with -Werror: ${ENABLE_WERROR}")

=== data/CMakeLists.txt ===

find_package(GSettings)

###########################
# Indicator service
###########################

set(
  INDICATOR_DIR
  "${CMAKE_INSTALL_FULL_DATADIR}/ayatana/indicators"
  CACHE FILEPATH "Ayatana Indicators Directory"
)

install(
  FILES "org.ayatana.indicator.sound"
  DESTINATION "${INDICATOR_DIR}"
)

###########################
# Systemd Job
###########################

pkg_check_modules(SYSTEMD systemd)
if (${SYSTEMD_FOUND})

  # where to install
  pkg_get_variable(SYSTEMD_USER_DIR systemd systemduserunitdir)
  message (STATUS "${SYSTEMD_USER_DIR} is the systemd user unit file install dir")

  set (SYSTEMD_USER_NAME "${CMAKE_PROJECT_NAME}.service")
  set (SYSTEMD_USER_FILE "${CMAKE_CURRENT_BINARY_DIR}/${SYSTEMD_USER_NAME}")
  set (SYSTEMD_USER_FILE_IN "${CMAKE_CURRENT_SOURCE_DIR}/${SYSTEMD_USER_NAME}.in")

  # build it
  set (pkglibexecdir "${CMAKE_INSTALL_FULL_PKGLIBEXECDIR}")
  configure_file ("${SYSTEMD_USER_FILE_IN}" "${SYSTEMD_USER_FILE}")

  # install it
  install (FILES "${SYSTEMD_USER_FILE}"
           DESTINATION "${SYSTEMD_USER_DIR}")
endif()

###########################
# XDG Autostart
###########################

set(
  INDICATOR_SOUND_XDG_AUTOSTART
  "${CMAKE_CURRENT_BINARY_DIR}/ayatana-indicator-sound.desktop"
)

configure_file(
  "ayatana-indicator-sound.desktop.in"
  ${INDICATOR_SOUND_XDG_AUTOSTART}
  @ONLY
)

install(
  FILES "${INDICATOR_SOUND_XDG_AUTOSTART}"
  DESTINATION "/etc/xdg/autostart"
)

###########################
# GSettings
###########################

add_schema ("org.ayatana.indicator.sound.gschema.xml")

if(NOT EXISTS /usr/share/glib-2.0/schemas/com.ubuntu.sound.gschema.xml)
  add_schema ("org.ayatana.sound.gschema.xml")
endif()

#########################################
# Accounts Service Iface: Sound Indicator
#########################################


set(POLKIT_LIB_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/polkit-1")
set(POLKIT_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/polkit-1")
set(DBUS_IFACE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/dbus-1/interfaces")
set(ACCOUNTS_IFACE_DIR "${CMAKE_INSTALL_FULL_DATADIR}/accountsservice/interfaces")

install(FILES org.ayatana.indicator.sound.AccountsService.xml
    DESTINATION "${DBUS_IFACE_DIR}"
)

# Create accountsservice symlink for above dbus interface
install(CODE "
    execute_process(COMMAND mkdir -p \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
    execute_process(COMMAND ln -sf ../../dbus-1/interfaces/org.ayatana.indicator.sound.AccountsService.xml \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
")

install(FILES org.ayatana.indicator.sound.AccountsService.policy
DESTINATION "${POLKIT_DATA_DIR}/actions"
)

install(FILES 50-org.ayatana.indicator.sound.AccountsService.pkla
DESTINATION "${POLKIT_LIB_DIR}/localauthority/10-vendor.d"
)

#######################################
# Accounts Service Iface: Greeter Sound
#######################################

if(EXISTS "/usr/share/accountsservice/interfaces/com.ubuntu.AccountsService.Sound.xml")

  # Nothing to do here...
  # Using files from Ubuntu specific package 'accountsservice-ubuntu-schemas'.

else()

  install(FILES org.ayatana.AccountsService.Sound.xml
      DESTINATION "${DBUS_IFACE_DIR}"
  )

  # Create accountsservice symlink for above dbus interface
  install(CODE "
      execute_process(COMMAND mkdir -p \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
      execute_process(COMMAND ln -sf ../../dbus-1/interfaces/org.ayatana.AccountsService.Sound.xml \"\$ENV{DESTDIR}${ACCOUNTS_IFACE_DIR}\")
  ")

  install(FILES org.ayatana.AccountsService.Sound.policy
  DESTINATION "${POLKIT_DATA_DIR}/actions"
  )

  install(FILES 50-org.ayatana.AccountsService.Sound.pkla
  DESTINATION "${POLKIT_LIB_DIR}/localauthority/10-vendor.d"
  )
endif()

=== src/CMakeLists.txt ===
###########################
# Vala Generation
###########################

set(HEADER_PATH "${CMAKE_CURRENT_BINARY_DIR}/indicator-sound-service.h")
set(SYMBOLS_PATH "${CMAKE_CURRENT_BINARY_DIR}/indicator-sound-service.def")
set(VAPI_PATH "${CMAKE_CURRENT_BINARY_DIR}/indicator-sound-service.vapi")

if(EXISTS "/usr/share/glib-2.0/schemas/com.ubuntu.sound.gschema.xml")
  set (VALA_DEFINE_UBUNTU_SOUND_SCHEMA "--define=HAS_UBUNTU_SOUND_SCHEMA")
endif()

if(EXISTS "/usr/share/accountsservice/interfaces/com.lomiri.touch.AccountsService.SecurityPrivacy.xml")
  set (VALA_FILE_ACCTSERVICE_PRIVACY_SETTINGS "accounts-service-privacy-settings")
  set (VALA_DEFINE_ACCTSERVICE_PRIVACY_SETTINGS "--define=HAS_LOMIRI_ACCTSERVICE_PRIVACY_SETTINGS")
endif()

if(EXISTS "/usr/share/accountsservice/interfaces/com.lomiri.touch.AccountsService.Sound.xml")
  set (HAS_LOMIRI_ACCTSERVICE_SYSTEMSOUND_SETTINGS ON)
  set (VALA_FILE_ACCTSERVICE_SYSTEMSOUND_SETTINGS "accounts-service-system-sound-settings")
  set (VALA_DEFINE_ACCTSERVICE_SYSTEMSOUND_SETTINGS "--define=HAS_LOMIRI_ACCTSERVICE_SYSTEMSOUND_SETTINGS")
else()
  set (HAS_LOMIRI_ACCTSERVICE_SYSTEMSOUND_SETTINGS OFF)
endif()

if(EXISTS "/usr/share/accountsservice/interfaces/com.ubuntu.AccountsService.Sound.xml")
  set (HAVE_UT_ACCTSERVICE_SOUND_SETTINGS ON)
  set (VALA_DEFINE_ACCTSERVICE_SOUND_SETTINGS "--define=HAS_UT_ACCTSERVICE_SOUND_SETTINGS")
else()
  set (HAVE_UT_ACCTSERVICE_SOUND_SETTINGS OFF)
endif()

vapi_gen(accounts-service
    LIBRARY
        accounts-service
    PACKAGES
        gio-2.0
    INPUT
        /usr/share/gir-1.0/AccountsService-1.0.gir
)

vala_init(ayatana-indicator-sound-service
  DEPENDS
    accounts-service
  PACKAGES
    config
    gee-0.8
    gio-2.0
    gio-unix-2.0
    libxml-2.0
    libpulse
    libpulse-mainloop-glib
    libnotify
    accounts-service
    AyatanaCommon
  OPTIONS
    --ccode
    --target-glib=${GLIB_2_0_REQUIRED_VERSION}
    --vapidir=${CMAKE_SOURCE_DIR}/vapi/
    --vapidir=.
    --pkg=bus-watcher
    ${VALA_DEFINE_UBUNTU_SOUND_SCHEMA}
    ${VALA_DEFINE_ACCTSERVICE_PRIVACY_SETTINGS}
    ${VALA_DEFINE_ACCTSERVICE_SOUND_SETTINGS}
    ${VALA_DEFINE_ACCTSERVICE_SYSTEMSOUND_SETTINGS}
)

vala_add(ayatana-indicator-sound-service
  notification.vala
)
vala_add(ayatana-indicator-sound-service
  info-notification.vala
  DEPENDS
    notification
      volume-control
        options
)
vala_add(ayatana-indicator-sound-service
  warn-notification.vala
  DEPENDS
    notification
)

vala_add(ayatana-indicator-sound-service
  service.vala
  DEPENDS
    sound-menu
    volume-control
    volume-control-pulse
    notification
    info-notification
    volume-warning
    options
    options-gsettings
    media-player
    media-player-list
    mpris2-interfaces
    accounts-service-user
    accounts-service-access
)

vala_add(ayatana-indicator-sound-service
  options.vala
  DEPENDS
    volume-control
    volume-control-pulse
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  options-gsettings.vala
  DEPENDS
    options
    volume-control-pulse
    volume-control
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  volume-control.vala
  DEPENDS
    options
    volume-control-pulse
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  accounts-service-access.vala
)
vala_add(ayatana-indicator-sound-service
  volume-control-pulse.vala
  DEPENDS
    accounts-service-access
    options
    volume-control
)
vala_add(ayatana-indicator-sound-service
  volume-warning.vala
  DEPENDS
    options
    volume-control-pulse
    volume-control
    warn-notification
    notification
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  volume-warning-pulse.vala
  DEPENDS
    volume-warning
    options
    volume-control-pulse
    volume-control
    warn-notification
    notification
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  media-player.vala
)
vala_add(ayatana-indicator-sound-service
  media-player-mpris.vala
  DEPENDS
    media-player
    mpris2-interfaces
)
vala_add(ayatana-indicator-sound-service
  media-player-user.vala
  DEPENDS
    media-player
    accounts-service-sound-settings
    greeter-broadcast
)
vala_add(ayatana-indicator-sound-service
  media-player-list.vala
  DEPENDS
    media-player
)
vala_add(ayatana-indicator-sound-service
  media-player-list-mpris.vala
  DEPENDS
    media-player-list
    media-player
    media-player-mpris
    mpris2-interfaces
)
vala_add(ayatana-indicator-sound-service
  media-player-list-greeter.vala
  DEPENDS
    media-player-list
    media-player-user
    media-player
)
vala_add(ayatana-indicator-sound-service
  mpris2-interfaces.vala
)
vala_add(ayatana-indicator-sound-service
  freedesktop-interfaces.vala
)
vala_add(ayatana-indicator-sound-service
  sound-menu.vala
  DEPENDS
    media-player
    volume-control
    options
    volume-control-pulse
    accounts-service-access
)
vala_add(ayatana-indicator-sound-service
  accounts-service-user.vala
  DEPENDS
    media-player
    mpris2-interfaces
    accounts-service-sound-settings
    ${VALA_FILE_ACCTSERVICE_PRIVACY_SETTINGS}
    ${VALA_FILE_ACCTSERVICE_SYSTEMSOUND_SETTINGS}
    greeter-broadcast
)
vala_add(ayatana-indicator-sound-service
  accounts-service-sound-settings.vala
)

if(${HAVE_UT_ACCTSERVICE_PRIVACY_SETTINGS})
    vala_add(ayatana-indicator-sound-service
          accounts-service-system-sound-settings.vala
    )
endif()

if(${HAS_LOMIRI_ACCTSERVICE_SYSTEMSOUND_SETTINGS})
    vala_add(ayatana-indicator-sound-service
          accounts-service-privacy-settings.vala
    )
endif()

vala_add(ayatana-indicator-sound-service
  greeter-broadcast.vala
)

vala_finish(ayatana-indicator-sound-service
  SOURCES
    project_VALA_SOURCES
  OUTPUTS
    project_VALA_C
  GENERATE_HEADER
    ${HEADER_PATH}
  GENERATE_SYMBOLS
    ${SYMBOLS_PATH}
  GENERATE_VAPI
    ${VAPI_PATH}
)

set_source_files_properties(
  ${project_VALA_SOURCES}
  PROPERTIES
  HEADER_FILE_ONLY TRUE
)

set(
  INDICATOR_SOUND_SOURCES
  ${project_VALA_SOURCES}
  ${project_VALA_C}
  bus-watch-namespace.c
  ${SYMBOLS_PATH}
)

###########################
# Lib
###########################

add_definitions(
  -w
  -DG_LOG_DOMAIN="ayatana-indicator-sound"
  -DVALA_EXTERN=extern
)

add_library(
    indicator-sound-service-lib STATIC
    ${INDICATOR_SOUND_SOURCES}
)

target_link_libraries(
  indicator-sound-service-lib
  ${SOUNDSERVICE_LIBRARIES}
  -lm
)

###########################
# Executable
###########################

include_directories(${CMAKE_BINARY_DIR})

add_executable(
  indicator-sound-service-bin
  main.c
)

set_target_properties(
  indicator-sound-service-bin
  PROPERTIES
  OUTPUT_NAME "ayatana-indicator-sound-service"
)

target_link_libraries(
  indicator-sound-service-bin
  indicator-sound-service-lib
  ${PULSEAUDIO_LIBRARIES}
)

###########################
# Installation
###########################

install(
  TARGETS indicator-sound-service-bin
  RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_LIBEXECDIR}/ayatana-indicator-sound/
)

if(UNITY_API_FOUND)
add_subdirectory(gmenuharness)
endif()

# coverage reporting
set(COVERAGE_TARGETS
  ${COVERAGE_TARGETS}
  indicator-sound-service-lib
  indicator-sound-service-bin
  PARENT_SCOPE
)

=== tests/CMakeLists.txt ===
find_package(GMock)
include_directories(${GMOCK_INCLUDE_DIRS})
include_directories("${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}/libdbustest-1")

###########################
# GSettings Schema
###########################

# build the necessary schemas
set_directory_properties (PROPERTIES
                          ADDITIONAL_MAKE_CLEAN_FILES gschemas.compiled)
set_source_files_properties (gschemas.compiled GENERATED)

# the home path needs to be severely below 108 characters of length, as pulseaudio
# will try to place a unix domain socket file in there... (i.e. in XDG_RUNTIME_DIR).
# In previous versions, the test-home was in the build directory somewhere, which failed
# when the source tree was stored in some deep sub/sub/sub/folders structure.
set (TEST_HOME "/tmp/build-home")
set (XDG_CONFIG_HOME "${TEST_HOME}/.config")
set (XDG_RUNTIME_DIR "${TEST_HOME}/.run")

add_custom_command (OUTPUT home.created
                    COMMAND mkdir -p ${TEST_HOME}
                    COMMAND mkdir -p ${XDG_RUNTIME_DIR}
                    COMMAND mkdir -p ${XDG_CONFIG_HOME}
)
add_custom_target (
             test-home ALL DEPENDS home.created
)

# GSettings:
# compile the indicator-sound schema into a gschemas.compiled file in this directory,
# and help the tests to find that file by setting -DSCHEMA_DIR
set (XDG_DATA_DIRS "${CMAKE_CURRENT_BINARY_DIR}/gsettings-schemas")
set (SCHEMA_DIR "${XDG_DATA_DIRS}/glib-2.0/schemas")
if (EXISTS /usr/share/glib-2.0/schemas/com.ubuntu.sound.gschema.xml)
  set (SOUND_SCHEMA /usr/share/glib-2.0/schemas/com.ubuntu.sound.gschema.xml)
  add_definitions ( -DHAS_UBUNTU_SOUND_SCHEMA )
else()
  set (SOUND_SCHEMA  ${CMAKE_SOURCE_DIR}/data/org.ayatana.sound.gschema.xml)
endif()
add_definitions(-DSCHEMA_DIR="${SCHEMA_DIR}")
execute_process (COMMAND ${PKG_CONFIG_EXECUTABLE} gio-2.0 --variable glib_compile_schemas
                 OUTPUT_VARIABLE COMPILE_SCHEMA_EXECUTABLE
                 OUTPUT_STRIP_TRAILING_WHITESPACE)
add_custom_command (OUTPUT gschemas.compiled
                    DEPENDS ${CMAKE_SOURCE_DIR}/data/org.ayatana.indicator.sound.gschema.xml
                    COMMAND mkdir -p ${SCHEMA_DIR}
                    COMMAND cp -f ${CMAKE_SOURCE_DIR}/data/org.ayatana.indicator.sound.gschema.xml ${SCHEMA_DIR}
                    COMMAND cp -f ${SOUND_SCHEMA} ${SCHEMA_DIR}
                    COMMAND ${COMPILE_SCHEMA_EXECUTABLE} ${SCHEMA_DIR})

add_custom_target (
             gschemas-compiled ALL DEPENDS gschemas.compiled
)

###########################
# Vala Mocks
###########################

set(VALA_MOCKS_HEADER_PATH "${CMAKE_CURRENT_BINARY_DIR}/vala-mocks.h")
set(VALA_MOCKS_SYMBOLS_PATH "${CMAKE_CURRENT_BINARY_DIR}/vala-mocks.def")

vala_init(vala-mocks
    DEPENDS
        indicator-sound-service-lib
    PACKAGES
        config
        gio-2.0
        gio-unix-2.0
        libxml-2.0
        libpulse
        libpulse-mainloop-glib
        libnotify
        accounts-service
        indicator-sound-service
    OPTIONS
        --ccode
        --vapidir=${CMAKE_BINARY_DIR}/src/
        --vapidir=${CMAKE_SOURCE_DIR}/vapi/
        --vapidir=.
)

set_source_files_properties(media-player-mock.c PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types -Wno-discarded-qualifiers")
set_source_files_properties(media-player-list-mock.c PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types -Wno-unused-variable")
set_source_files_properties(options-mock.c PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types -Wno-unused-variable")
set_source_files_properties(volume-control-mock.c PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types -Wno-int-to-pointer-cast -Wno-implicit-function-declaration")
set_source_files_properties(volume-warning-mock.c PROPERTIES COMPILE_FLAGS "${CMAKE_C_FLAGS} -Wno-incompatible-pointer-types -Wno-unused-variable -Wno-int-to-pointer-cast -Wno-implicit-function-declaration")

vala_add(vala-mocks
    media-player-mock.vala
)

vala_add(vala-mocks
    media-player-list-mock.vala
)

vala_add(vala-mocks
    options-mock.vala
)

vala_add(vala-mocks
    volume-control-mock.vala
)

vala_add(vala-mocks
    volume-warning-mock.vala
)

vala_finish(vala-mocks
    SOURCES
        vala_mocks_VALA_SOURCES
    OUTPUTS
        vala_mocks_VALA_C
    GENERATE_HEADER
        ${VALA_MOCKS_HEADER_PATH}
    GENERATE_SYMBOLS
        ${VALA_MOCKS_SYMBOLS_PATH}
)

set_source_files_properties(
    ${vala_mocks_VALA_SOURCES}
    PROPERTIES
    HEADER_FILE_ONLY TRUE
)

set(
    VALA_MOCKS_SOURCES
    ${vala_mocks_VALA_SOURCES}
    ${vala_mocks_VALA_C}
    ${VALA_MOCKS_SYMBOLS_PATH}
)

add_definitions(
    -Wno-unused-but-set-variable
    -DVALA_EXTERN=extern
)

add_library(
    vala-mocks-lib STATIC
    ${VALA_MOCKS_SOURCES}
)

target_link_libraries(
    vala-mocks-lib
    indicator-sound-service-lib
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

###########################
# Pulse Mock
###########################

add_library(
    pulse-mock
    SHARED
    pa-mock.cpp
)

target_link_libraries (pulse-mock ${PULSEAUDIO_LIBRARIES})

###########################
# Name Watch Test
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (name-watch-test name-watch-test.cc ${CMAKE_SOURCE_DIR}/src/bus-watch-namespace.c)
target_link_options (name-watch-test PRIVATE -no-pie)
target_link_libraries (name-watch-test ${SOUNDSERVICE_LIBRARIES} ${GMOCK_LIBRARIES})
add_test(name-watch-test name-watch-test)

###########################
# Accounts Service User
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (accounts-service-user-test accounts-service-user.cc)
target_link_options (accounts-service-user-test PRIVATE -no-pie)
target_link_libraries (
    accounts-service-user-test
    indicator-sound-service-lib
    vala-mocks-lib
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

# Split tests to work around libaccountservice sucking
add_test(accounts-service-user-test-basic
    accounts-service-user-test  --gtest_filter=AccountsServiceUserTest.BasicObject
)

add_test(accounts-service-user-test-player
    accounts-service-user-test  --gtest_filter=AccountsServiceUserTest.SetMediaPlayer
)

###########################
# Volume Control
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (volume-control-test volume-control-test.cc)
add_dependencies (volume-control-test gschemas-compiled)
target_link_options (volume-control-test PRIVATE -no-pie)
target_link_libraries (
    volume-control-test
    indicator-sound-service-lib
    vala-mocks-lib
    pulse-mock
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

add_test(volume-control-test volume-control-test)

###########################
# Sound Menu
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (sound-menu-test sound-menu.cc)
target_link_options (sound-menu-test PRIVATE -no-pie)
target_link_libraries (
    sound-menu-test
    indicator-sound-service-lib
    vala-mocks-lib
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

add_test(sound-menu-test sound-menu-test)

###########################
# Notification Test
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (notifications-test notifications-test.cc)
target_link_options (notifications-test PRIVATE -no-pie)
target_link_libraries (
    notifications-test
    indicator-sound-service-lib
    vala-mocks-lib
    pulse-mock
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

add_test(notifications-test notifications-test)

###########################
# Accounts Service User
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (media-player-user-test media-player-user.cc)
target_link_options (media-player-user-test PRIVATE -no-pie)
target_link_libraries (
    media-player-user-test
    indicator-sound-service-lib
    vala-mocks-lib
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

# Split tests to work around libaccountservice sucking
add_test(media-player-user-test-basic
    media-player-user-test  --gtest_filter=MediaPlayerUserTest.BasicObject
)
add_test(media-player-user-test-dataset
    media-player-user-test  --gtest_filter=MediaPlayerUserTest.DataSet
)
add_test(media-player-user-test-timeout
    media-player-user-test  --gtest_filter=MediaPlayerUserTest.TimeoutTest
)

###########################
# Greeter List
###########################

include_directories(${CMAKE_SOURCE_DIR}/src)
add_executable (greeter-list-test greeter-list.cc)
target_link_options (greeter-list-test PRIVATE -no-pie)
target_link_libraries (
    greeter-list-test
    indicator-sound-service-lib
    vala-mocks-lib
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

# Split tests to work around libaccountservice sucking
add_test(greeter-list-test-basic
    greeter-list-test  --gtest_filter=GreeterListTest.BasicObject
)
add_test(greeter-list-test-iterator
    greeter-list-test  --gtest_filter=GreeterListTest.BasicIterator
)

###########################
# Indicator Test
###########################

add_definitions(
    -DINDICATOR_SOUND_SERVICE_BINARY="${CMAKE_BINARY_DIR}/src/ayatana-indicator-sound-service"
    -DPA_MOCK_LIB="${CMAKE_CURRENT_BINARY_DIR}/libpulse-mock.so"
)
add_executable (indicator-test indicator-test.cc)
add_dependencies (indicator-test gschemas-compiled)
target_link_options (indicator-test PRIVATE -no-pie)
target_link_libraries (
    indicator-test
    ${SOUNDSERVICE_LIBRARIES}
    ${TEST_LIBRARIES}
    ${GMOCK_LIBRARIES}
)

# Split tests to work around libaccountservice sucking
add_test(indicator-test
    indicator-test
)

if(UNITY_API_FOUND)
add_subdirectory(integration)
endif()
add_subdirectory(dbus-types)
add_subdirectory(service-mocks)

# coverage reporting
set(COVERAGE_TEST_TARGETS
  ${COVERAGE_TEST_TARGETS}
  name-watch-test
  accounts-service-user-test
  volume-control-test
  sound-menu-test
  notifications-test
  media-player-user-test
  greeter-list-test
  indicator-test
  PARENT_SCOPE
)

=== tests/integration/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

#pkg_check_modules(GMENUHARNESS REQUIRED libgmenuharness REQUIRED)
#include_directories(${GMENUHARNESS_INCLUDE_DIRS})
include_directories("${CMAKE_SOURCE_DIR}/include")

pkg_check_modules(QTDBUSTEST REQUIRED libqtdbustest-1 REQUIRED)
include_directories(${QTDBUSTEST_INCLUDE_DIRS})

pkg_check_modules(QTDBUSMOCK REQUIRED libqtdbusmock-1 REQUIRED)
include_directories(${QTDBUSMOCK_INCLUDE_DIRS})

find_package(Qt5Test REQUIRED)
include_directories(${Qt5Test_INCLUDE_DIRS})

find_package(Qt5DBus REQUIRED)
include_directories(${Qt5DBus_INCLUDE_DIRS})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${GMOCK_INCLUDE_DIRS})

include_directories("${CMAKE_SOURCE_DIR}/tests/dbus-types")
include_directories("${CMAKE_BINARY_DIR}/tests/dbus-types")

add_definitions(-DSOUND_SERVICE_BIN="${CMAKE_BINARY_DIR}/src/ayatana-indicator-sound-service"
                -DSTREAM_RESTORE_TABLE="${CMAKE_SOURCE_DIR}/tests/integration/touch-stream-restore.table"
                -DVOLUME_SET_BIN="${CMAKE_BINARY_DIR}/tests/integration/set-volume"
                -DACCOUNTS_SERVICE_BIN="${CMAKE_BINARY_DIR}/tests/service-mocks/accounts-mock/accounts-service-sound"
                -DMEDIA_PLAYER_MPRIS_BIN="${CMAKE_BINARY_DIR}/tests/service-mocks/media-player-mpris-mock/media-player-mpris-mock"
                -DMEDIA_PLAYER_MPRIS_UPDATE_BIN="${CMAKE_BINARY_DIR}/tests/service-mocks/media-player-mpris-mock/media-player-mpris-mock-update"
                -DTEST_SOUND="${CMAKE_SOURCE_DIR}/tests/integration/test-sound.wav"
                -DQT_NO_KEYWORDS=1
                -DXDG_DATA_DIRS="${XDG_DATA_DIRS}"
                -DXDG_CONFIG_HOME="${XDG_CONFIG_HOME}"
                -DXDG_RUNTIME_DIR="${XDG_RUNTIME_DIR}"
                -DTEST_HOME="${TEST_HOME}"
)

if(EXISTS "/usr/share/accountsservice/interfaces/com.ubuntu.AccountsService.Sound.xml")
    add_definitions(-DHAS_UT_ACCTSERVICE_SOUND_SETTINGS)
endif()

set(GLIB_REQUIRED_VERSION 2.26)

pkg_check_modules(
  GLIB REQUIRED
  glib-2.0>=${GLIB_REQUIRED_VERSION}
  gio-2.0>=${GLIB_REQUIRED_VERSION}
)
include_directories(${GLIB_INCLUDE_DIRS})

set(
    INTEGRATION_TESTS_SRC
    indicator-sound-test-base.cpp
    test-indicator.cpp
    utils/dbus-pulse-volume.cpp
    main.cpp
)

add_executable(
    integration-tests
    ${INTEGRATION_TESTS_SRC}
)

add_dependencies(
    integration-tests
    test-home
)

qt5_use_modules(
    integration-tests
    Core
    DBus
    Test
)

target_link_options (integration-tests PRIVATE -no-pie)
target_link_libraries(
    integration-tests
    sound-indicator-dbus-interfaces
    ${QTDBUSMOCK_LDFLAGS}
    ${QTDBUSTEST_LDFLAGS}
    ${GMOCK_LIBRARIES}
#    ${GMENUHARNESS_LDFLAGS}
    ${GLIB_LDFLAGS}
    gmenuharness-shared
)

add_test(
    integration-tests
    integration-tests
)

set(
    SET-VOLUME-SRC
    utils/dbus-pulse-volume.cpp
    utils/set-volume.cpp
)

set(
    GET-VOLUME-SRC
    utils/dbus-pulse-volume.cpp
    utils/get-volume.cpp
)

add_executable(
    set-volume
    ${SET-VOLUME-SRC}
)

add_dependencies(
    set-volume
    test-home
)

add_executable(
    get-volume
    ${GET-VOLUME-SRC}
)

add_dependencies(
    get-volume
    test-home
)

qt5_use_modules(
    set-volume
    Core
    DBus
    Test
)

qt5_use_modules(
    get-volume
    Core
    DBus
    Test
)

target_link_libraries(
    get-volume
    sound-indicator-dbus-interfaces
)

target_link_libraries(
    set-volume
    sound-indicator-dbus-interfaces
)

# coverage reporting
set(COVERAGE_TEST_TARGETS
  ${COVERAGE_TEST_TARGETS}
  integration-tests
  PARENT_SCOPE
)

=== debian/changelog ===
ayatana-indicator-sound (0.8.2-0+git20211102.2976+10.nightly.1) buster; urgency=medium

  * Development-Snapshot!!! Auto-built Debian buster package for
    packages.arctica-project.org repository (Git commit:
    8fe910c4032192882df4bab6524a2378765ca8dc).

 -- Mike Gabriel <arctica-builder@porty.informatik.uni-kiel.de>  Tue, 02 Nov 2021 22:16:04 +0100

ayatana-indicator-sound (0.8.2-0) unstable; urgency=medium

  * Upstream-provided Debian package for ayatana-indicator-sound.
    See upstream ChangeLog for recent changes.

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Thu, 28 Jan 2021 16:54:23 +0100

ayatana-indicator-sound (0.8.1-0) unstable; urgency=medium

  * Upstream-provided Debian package for ayatana-indicator-sound.
    See upstream ChangeLog for recent changes.

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Thu, 10 Sep 2020 21:44:51 +0200

ayatana-indicator-sound (0.8.0-0) unstable; urgency=medium

  * Fork from Ubuntu's indicator-sound.

 -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Sun, 06 May 2017 00:14:32 +0200

indicator-sound (12.10.2+17.04.20170328.1-0ubuntu1) zesty; urgency=medium

  * Disable integration tests when running under jenkins environment for
    now.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Tue, 28 Mar 2017 15:04:32 +0000

indicator-sound (12.10.2+17.04.20170208-0ubuntu1) zesty; urgency=medium

  * Remove old autostart files.
  * Remove the local gsettings cmake module which we don't need/use.
  * Use only the gmock module from cmake-extras.
  * Use coverage support from cmake-extras.
  * Use intltool support from cmake-extras.

 -- Rodney Dawes <rodney.dawes@canonical.com>  Wed, 08 Feb 2017 04:38:44 +0000

indicator-sound (12.10.2+17.04.20170109-0ubuntu1) zesty; urgency=medium

  * Compatibility with unversioned cmake-extras modules (LP: #1563573)

 -- Pete Woods <pete.woods@canonical.com>  Mon, 09 Jan 2017 14:20:04 +0000

indicator-sound (12.10.2+17.04.20161201-0ubuntu1) zesty; urgency=medium

  [ Michael Terry ]
  * Work when inside a snap by prefixing hard coded paths with $SNAP.
    (LP: #1629009, #1645833)

 -- Rodney Dawes <rodney.dawes@canonical.com>  Thu, 01 Dec 2016 22:33:58 +0000

indicator-sound (12.10.2+17.04.20161021-0ubuntu1) zesty; urgency=medium

  [ Ted Gould ]
  * Adding systemd user session unit

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 21 Oct 2016 10:16:33 +0000

indicator-sound (12.10.2+16.04.20160418.1-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * This branch adds a new signal in volumeWarning to set the warning
    level volume after pressing cancel. We are setting the warning level
    before pressing cancel, which is alright, but sometimes we have
    issues with the value set to the accounts service that steps on the
    warning level. (LP: #1570779)

 -- Xavi Garcia <xavi.garcia.mena@canonical.com>  Mon, 18 Apr 2016 09:18:16 +0000

indicator-sound (12.10.2+16.04.20160406-0ubuntu1) xenial; urgency=medium

  * Support multiple desktop names in $XDG_CURRENT_DESKTOP. (LP:
    #1502480)

 -- Dmitry Shachnev <mitya57@gmail.com>  Wed, 06 Apr 2016 19:05:13 +0000

indicator-sound (12.10.2+16.04.20160317.1-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * Changed to code to get the root icon. Now it does not take into
    account the source output, as in fact that code was not
    differentiating between any particular case. The code was added in
    the past in the case that we should differentiate between bluetooth,
    headphones, etc... but it was never used. (LP: #1555831)

 -- Xavi Garcia <xavi.garcia.mena@canonical.com>  Thu, 17 Mar 2016 10:06:26 +0000

indicator-sound (12.10.2+16.04.20160307-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * Add changes to show up the microphone controls when an external
    microphone is detected.
  * This branch sets the last running player using accounts service
    instead of gsettings. It also includes a new class
    AccountsServiceAccess, to centralize all accesses to account service
    properties.
  * To avoid going too below the warning level we set the volume when
    showing the warning dialog to the loud_volume level.

 -- Xavi Garcia <xavi.garcia.mena@canonical.com>  Mon, 07 Mar 2016 10:13:55 +0000

indicator-sound (12.10.2+16.04.20160216-0ubuntu1) xenial; urgency=medium

  [ Matthias Klose ]
  * Build using libgee-0.8-dev instead of libgee-dev (LP: #1502094)

 -- Marco Trevisan (Treviño) <mail@3v1n0.net>  Tue, 16 Feb 2016 15:44:36 +0000

indicator-sound (12.10.2+16.04.20160210-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * This branch modifies the sound indicator on the desktop to only show
    the playback controls for those players that are active or (if any
    is running) the last one being active. (LP: #1213907)

 -- Xavi Garcia <xavi.garcia.mena@canonical.com>  Wed, 10 Feb 2016 13:22:08 +0000

indicator-sound (12.10.2+16.04.20160120-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * Fixing the playback controls when we have the playlist as the last
    item in the player section. As number of items was 3 when having the
    playlist section we were not updating the player controls and the
    next/previous buttons were not working at all. (LP: #1245495)

 -- Xavi Garcia <xavi.garcia.mena@canonical.com>  Wed, 20 Jan 2016 17:31:39 +0000

indicator-sound (12.10.2+16.04.20160113.1-0ubuntu1) xenial; urgency=medium

  [ Charles Kerr ]
  * Be more selective about when to show and dismiss the High Volume
    Warning Dialog. (LP: #1504065)

  [ charles kerr ]
  * Be more selective about when to show and dismiss the High Volume
    Warning Dialog. (LP: #1504065)

 -- Charles Kerr <charles.kerr@canonical.com>  Wed, 13 Jan 2016 20:37:58 +0000

indicator-sound (12.10.2+16.04.20160105.2-0ubuntu1) xenial; urgency=medium

  [ Xavi Garcia Mena ]
  * Adds an action to signal the UI to sync the current volume when we
    are waiting for the user to confirm or reject the high volume


=== debian/control ===
Source: ayatana-indicator-sound
Section: nightly/sound
Priority: optional
Maintainer: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Build-Depends: debhelper (>= 10),
               dh-systemd | hello,
               cmake,
               cmake-extras (>= 0.10),
               dbus,
               dbus-test-runner (>> 14.04.0+14.04.20150120.1),
               gcovr,
               gir1.2-accountsservice-1.0,
               googletest | google-mock (>= 1.6.0+svn437),
               intltool,
               autotools-dev,
               valac (>= 0.20),
               lcov,
               libaccountsservice-dev,
               libayatana-common-dev (>= 0.9.3),
               libdbustest1-dev (>= 15.04.0),
               libgirepository1.0-dev,
               libglib2.0-dev (>= 2.32.0),
               libgtest-dev,
               libqtdbusmock1-dev (>= 0.3),
               libqtdbustest1-dev,
               liblomiri-api-dev (>= 0.1.1) | hello,
               libpulse-dev (>= 5.0),
               libpulse-mainloop-glib0 (>= 0.9.18),
               libnotify-dev,
               libgee-0.8-dev,
               libxml2-dev,
               pulseaudio,
               python3-dbusmock,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               systemd [linux-any],
Standards-Version: 4.1.1
Homepage: https://github.com/ArcticaProject/ayatana-indicator-sound
Vcs-Git: git://cgit.arctica-project.org/ayatana/ayatana-indicator-sound.git
Vcs-Browser: https://cgit.arctica-project.org/ayatana/ayatana-indicator-sound.git/

Package: ayatana-indicator-sound
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         pulseaudio,
         ayatana-indicator-common,
         libglib2.0-bin,
Recommends: unity-control-center | gnome-control-center | pavucontrol | mate-media,
            accountsservice,
Suggests: ayatana-greeter-session-broadcast,
Description: Ayatana Indicator for managing system sound
 Ayatana Indicator Sound that provides easy control of the PulseAudio
 sound daemon.
